#include <at89LP4052.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <rtx51tny.h>

#define  MASK    0x07

#define  SYSTEM  0
#define  ERRORS  1
#define  SERIAL  2

typedef enum {NO_OK=0, YES_OK=1, DIR_R=2, DIR_L=3} Chyby;
typedef enum {OFF=0, ON=1} Stavy;
typedef enum {R=0, L=1} Smery;

char DIR;              //Vysledok zistenia faz ...
sbit ERR  = P3^2;      //ERR=0 je chyba, ERR=1 je OK
sbit LEDR = P3^3;      //LED signalizujuca otacanie sa faz RIGHT
sbit LEDL = P3^4;      //LED signalizujuca otacanie sa faz LEFT
sbit TEST = P3^5;
                  //123456   123456
code char *Smer[]={"645132","623154"};
data char Poradie_X[12];
code char *Message[]={"NOT_OK","OK","RIGHT","LEFT"};

unsigned char Port(unsigned char Maska) 
{
 code char Tab[]="01234567"; //Najlepsie je to namapovat na prve porty P1, P3 .... ine by boli komplikovanejsie ...
 return Tab[(P1&Maska)];
}

#ifdef RS232

void Serial(void) _task_ SERIAL
{
 PCON|=0x80;
 SCON=0x50;
 TMOD|=0x20;
 TH1=TL1=0x100-((0x100-0xFB)*12);		//Je to predsa Single Cycle processor ....
 TR1=1;
 TI=1;
 printf("System Ready ...\r\n");
 while(1)
  {
   switch(os_wait(K_TMO+K_SIG,30,NULL))
    {
     case TMO_EVENT : printf("Smer otacania faz = %s\r\n",Message[DIR]);break;
     case SIG_EVENT : printf("Chyba %02bd\r\n",DIR); break;
    }
  }
}

#endif

void Errors(void) _task_ ERRORS
{
 ERR=YES_OK;
 while(1)
  {
   switch(os_wait(K_TMO+K_SIG,25,NULL))
    {
     case TMO_EVENT : ERR=NO_OK;
                      DIR=NO_OK; 
                      os_send_signal(SERIAL);          //Ak do 25ms nepride K_SIG tak hlasim chybu ....
                      break;
     case SIG_EVENT : ERR=YES_OK; break;               //Nulujem stale WDT, inac by to skoncilo chybou ...
    }
  }
}

void System(void) _task_ SYSTEM
{
 char *Test;
 unsigned char i;
 P1M0=P3M0=P1M1=P3M1=0x00;														 //Nastavim porty ako vstupne ... je to ine ako AT89C4051 !!!
 #ifdef RS232
 os_create_task(SERIAL);
 #endif
 os_create_task(ERRORS);                               //Spustim Watchdog na pritomnost faz ....
 while(1)
  {
   for(i=0x00; i<sizeof(Poradie_X); i++)
    {
     Poradie_X[i]=Port(MASK);                          //Nastavim kombinaciu faz ....
     while(Poradie_X[i]==Port(MASK)) os_switch_task(); //Cakam kym tato kombinacia neskonci ....
     os_send_signal(ERRORS);                           //Odoslem signal o pritomnosti faz, ak skonci TMO_EVENT je to chyba
    }
   if((Test=strstr(Poradie_X,Smer[L]))!=NULL) DIR=DIR_L; //Smer otacania sa faz je vlavo
   if((Test=strstr(Poradie_X,Smer[R]))!=NULL) DIR=DIR_R; //Smer otacania sa faz je vpravo
   switch(DIR)                                           //Nastavim OK, alebo ERROR
    {
     case DIR_R : LEDR=ON; LEDL=OFF; ERR=YES_OK; break;
     case DIR_L : LEDL=ON; LEDR=OFF; ERR=YES_OK; break;
     default    : LEDL=LEDR=OFF; ERR=NO_OK; break;
    }
  }
}